---
title: Headers.delete()
slug: Web/API/Headers/delete
tags:
  - API
  - Experimental
  - Fetch
  - Method
  - Reference
  - delete
---
<div>{{APIRef("Fetch")}}</div>

<p>The <strong><code>delete()</code></strong> method of the {{domxref("Headers")}} interface deletes a header from the current <code>Headers</code> object.</p>

<p>This method throws a {{jsxref("TypeError")}} for the following reasons:</p>

<ul>
 <li>The value of the name parameter is not the name of an HTTP header.</li>
 <li>The value of {{Glossary("Guard")}} is <code>immutable</code>.</li>
</ul>

<p>For security reasons, some headers can only be controller by the user agent. These headers include the {{Glossary("Forbidden_header_name", "forbidden header names", 1)}} and {{Glossary("Forbidden_response_header_name", "forbidden response header names", 1)}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>myHeaders</em>.delete(<em>name</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>name</code></dt>
 <dd>The name of the HTTP header you want to delete from the <code>Headers</code> object.</dd>
</dl>

<h3 id="Returns">Returns</h3>

<p>Void.</p>

<h2 id="Example">Example</h2>

<p>Creating an empty <code>Headers</code> object is simple:</p>

<pre class="brush: js">var myHeaders = new Headers(); // Currently empty</pre>

<p>You could add a header to this using {{domxref("Headers.append")}}:</p>

<pre class="brush: js">myHeaders.append('Content-Type', 'image/jpeg');
myHeaders.get('Content-Type'); // Returns 'image/jpeg'
</pre>

<p>You can then delete it again:</p>

<pre class="brush: js">myHeaders.delete('Content-Type');
myHeaders.get('Content-Type'); // Returns null, as it has been deleted</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Fetch','#dom-headers-delete','delete()')}}</td>
   <td>{{Spec2('Fetch')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Headers.delete")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Access_control_CORS">HTTP access control (CORS)</a></li>
 <li><a href="/en-US/docs/Web/HTTP">HTTP</a></li>
</ul>
